//=============================================================================
// PulseGun.
// Some fixing for A.I. and so on
// Beam reworked and collision height when gets dropped... Too tall...
//=============================================================================
class EPulseGun extends PulseGun;

simulated event RenderOverlays( canvas Canvas )
{
	if ( AmmoType == None || ( Pawn(Owner) == None || Pawn(Owner).Health <= 0 ) )
		return;
	Texture'Ammoled'.NotifyActor = Self;
	if (Pawn(Owner) != None)
		Super.RenderOverlays(Canvas);
	Texture'Ammoled'.NotifyActor = None;
}

simulated event RenderTexture(ScriptedTexture Tex)
{
	local Color C;
	local string Temp;

	if ( AmmoType == None ) return;
	if ( AmmoType.AmmoAmount == 0 ) Temp = "000";
	if ( Pawn(Owner) != None && !bHidden )
	{
//		log ( Self$" my Owner is "$Owner.GetHumanName());
//		log (Self$" my state: "$GetStateName());
		Temp = String(AmmoType.AmmoAmount);
//		log (Self$ " have Temp: "$Temp);
		while(Len(Temp) < 3) Temp = "0"$Temp;
		Tex.DrawTile( 30, 100, (Min(AmmoType.AmmoAmount,AmmoType.Default.AmmoAmount)*196)/AmmoType.Default.AmmoAmount, 10, 0, 0, 1, 1, Texture'AmmoCountBar', False );
		if ( AmmoType.AmmoAmount < 10 )
		{
			C.R = 255;
			C.G = 0;
			C.B = 0;
		}
		else
		{
			C.R = 0;
			C.G = 0;
			C.B = 255;
		}
		Tex.DrawColoredText( 56, 14, Temp, Font'LEDFont', C );
	}
}

simulated function TweenToStill() //LOL
{
	if ( Mesh != PickupViewMesh )
		TweenAnim('Still', 0.1);
}

simulated function PlaySelect()
{
	bForceFire = false;
	bForceAltFire = false;
	bCanClientFire = false;
	if ( Mesh == PlayerViewMesh )
	{
		if ( !IsAnimating() || (AnimSequence != 'Select') )
			PlayAnim('Select',1.0,0.0);
	}
	if ( Owner != None )
		Owner.PlaySound(SelectSound, SLOT_Misc, Pawn(Owner).SoundDampening);
}

simulated function TweenDown()
{
	if ( Mesh == PlayerViewMesh )
	{
		if ( IsAnimating() && (AnimSequence != '') && (GetAnimGroup(AnimSequence) == 'Select') )
			TweenAnim( AnimSequence, AnimFrame * 0.4 );
		else
			PlayAnim('Down', 1.0, 0.05);
	}
}

function CheckVisibility()
{
	local Pawn PawnOwner;

	PawnOwner = Pawn(Owner);

	if ( PawnOwner != None )
		if ( Owner.bHidden && (PawnOwner.Health > 0) && (PawnOwner.Visibility < PawnOwner.Default.Visibility) )
		{
			Owner.bHidden = false;
			PawnOwner.Visibility = PawnOwner.Default.Visibility;
		}
}

defaultproperties
{
     WeaponDescription="Classification: Plasma Rifle"
     ProjectileClass=Class'NsDM3.ExPlasmaSphere'
     AltProjectileClass=Class'NsDM3.EStarterBolt'
     CollisionHeight=12.000000
}
