class Tweaker extends Actor;

#exec Texture Import File=Textures\L_Exit.pcx Name=L_Exit Mips=Off Flags=2
#exec Texture Import File=Textures\L_Center.pcx Name=L_Center Mips=Off Flags=2
#exec Texture Import File=Textures\I_Spot.pcx Name=I_Spot Mips=Off Flags=2
#exec Texture Import File=Textures\strawberry.pcx Name=strwbr Mips=Off Flags=2

var bool bInitialized, bSwarmer;

event PreBeginPlay()
{
}

function PostBeginPlay()
{
	if (bInitialized) return;
	bInitialized = True;
	DevelopJumps();
	SetTimer(1/Level.TimeDilation*2.00,True);
	log ("A tweaker has been spawned.");
	Super.PostBeginPlay();
}

function DevelopJumps()
{
	local NavigationPoint N;
	local DummyTarget DT;
	local Inventory I;

	if ((Level.Game).IsA('DeathMatchPlus') && DeathMatchPlus(Level.Game).bUseTranslocator)
	{
		for ( N=Level.NavigationPointList; N!=None; N=N.nextNavigationPoint )
		{
			if ( N != None )
			{
				if (InventorySpot(N) != None)
					DT = Spawn( class'DummyTarget',,,N.Location+Vect(0,0,5) );
			}
		}
		foreach AllActors (class 'Inventory', I)
		{
			if (I != None && I.MyMarker != None && VSize(I.Location-I.MyMarker.Location) > 10)
				I.SetLocation(I.MyMarker.Location+vect(0,0,-25));
		}
	}
}

event timer()
{
	local ScriptedPawn S;
	local Pawn P, En, Ben;
	local Bot B;
	local PlayerPawn Tp;
	local name gstate;
	local NavigationPoint NP, Nopt;
	local DummyTarget DT;
	local int i, Npw;
	local bool bFoundTarget, bMightHunt;
	local Inventory Iv;
	local TranslocatorTarget Tt;

	if (!bSwarmer)
	{
		Spawn(Class'SS');
		bSwarmer=True;
	}

	foreach AllActors(class'Pawn',P)
//	for (P=Level.PawnList; P!=None; P=P.NextPawn)
	{
		S = ScriptedPawn(P);
		B = Bot(P);
		Tp = PlayerPawn(P);
		Npw++;
		if ( Npw > 64 )
		{
			Npw = 0;
			break;
		}
		if ( B != None && B.Health > 0 && B.MoveTimer > 0 && B.SpecialPause == 0)
		{
			Foreach B.ChildActors (class 'TranslocatorTarget', Tt)
			{
				if (Tt != None && CTFTranslocatorTarget(Tt) == None) Tt.Destroy();
			}
			if ( B.MyTranslocator != None && B.bCanTranslocate )
			{
				Foreach RadiusActors (class 'DummyTarget',DT,910,B.Location)
				{
					if ( DT != None && FastTrace(B.Location,DT.Location) && B.bCanTranslocate
					&& !DT.Region.Zone.bWaterZone && VSize(DT.Location-B.Location) > 300
					&& !B.HeadRegion.Zone.bWaterZone) // forced recheck
					{
						B.DesiredRotation=Rotator(DT.Location-B.Location);
						B.Target = DT;
						B.TranslocateToTarget(DT);
						B.bCanTranslocate = False;
						//break;
					}
				}
				foreach VisibleCollidingActors(class'Inventory',Iv,910,B.Location,True)
				{
					if ( Iv != None && B.LineOfSightTo(Iv) && B.FindInventoryType(Iv.class) == None
					&& !Iv.Region.Zone.bWaterZone && (Iv.Location.Z-B.Location.Z > 60))
					{
						B.Target = Iv;
						B.TranslocateToTarget(Iv);
						B.MoveTarget = Iv;
						B.bCanTranslocate = False;
					}
				}
				foreach VisibleCollidingActors ( class 'Pawn',Ben,B.SightRadius,B.Location,True )
				{
					Npw++;
					if ( ( B.Enemy == None || ( B.Enemy != None && !B.LineOfSightTo(B.Enemy) )) && Ben != B )
					if ( Ben.Health > 0 && !Ben.bHidden && Ben.Mesh != None && Ben.bCollideActors )
					{
						B.SeePlayer(Ben);
						break;
					}
				}
			}
//			log ("Tweak Bot");
		}
		if ( S != None && S.Health > 0 )
		{
			if ( S.IsA('Nali') || S.IsA('Cow') )
				continue;
			foreach VisibleCollidingActors ( class'Pawn',En,S.SightRadius,S.Location,True )
			{
				if ( En.PlayerReplicationInfo != None && En != S
				&& En.Health > 0 && En.bBlockActors && ( S.Enemy == None || !S.LineOfSightTo(S.Enemy)) )
				{
					S.bHunting = True;
					S.Hated = En;
					S.Enemy = En;
					S.LastSeenPos = En.Location;
					S.GotoState('Attacking');
					if (En.IsA('Bot'))
					{
						if (Bot(En).Enemy == None || (VSize(S.Location - Bot(En).Location) < VSize(Bot(En).Enemy.Location-Bot(En).Location) ))
						Bot(En).Enemy = S;
					}
					break;
				}
			}
			if ( S.Enemy == None )
			foreach RadiusActors (class'NavigationPoint',Nopt,750,S.Location)
			{
				if ( FastTrace (S.Location,Nopt.Location) )
				{
					bMightHunt = True;
					break;
				}
			}
			if (bMightHunt)
			{
			foreach RadiusActors ( class 'Pawn',En,4096,S.Location )
			{
				Npw++;
				if ( En.PlayerReplicationInfo != None && En != S
				&& En.Health > 0 && !En.bHidden && En.bBlockActors )
				{
					if ( S.Enemy == None  || ( S.Enemy != None && !S.LineOfSightTo(S.Enemy) && FRand() > 0.7 ) && S.Enemy != En )
					{
						S.bHunting = True;
						S.Hated = En;
						S.Enemy = En;
						S.LastSeenPos = En.Location;
						S.GotoState('Attacking');
						if (Bot(En) != None)
						{
							if (Bot(En).Enemy == None || (VSize(S.Location - Bot(En).Location) < VSize(Bot(En).Enemy.Location-Bot(En).Location) ))
							Bot(En).Enemy = S;
						}
						break;
					}
				}
			}
			bMightHunt = False;
			}
			if ((Level.Game).bTeamGame)
			{
				if ( S.Enemy != None && ScriptedPawn(S.Enemy) != None )
				{
					S.Hated = None;
					S.Enemy = None;
					S.bHunting = False;
					S.Target = None;
					if ( S.OldEnemy != None && S.OldEnemy.IsA('ScriptedPawn') )
						S.OldEnemy = None;
					S.GotoState('Waiting');
					S.TeamTag = 'Arn';
				}
			}
//			log ( "End monster tweak");
		}
	}
	if ((Level.Game).bGameEnded) Destroy();
}

defaultproperties
{
     bHidden=True
     bGameRelevant=True
     bMovable=False
     NetUpdateFrequency=2.000000
}
